<script>
import ContentContainer from "../../reusableComponents/ContentContainer.vue";
import ProceedingList from "./components/ProceedingList.vue";
import ProceedingStatistics from "./components/ProceedingStatistics.vue";
import AppointmentList from "./components/AppointmentList.vue";
import Documentations from "./components/Documentations.vue";
import ProceedingMap from "./components/ProceedingMap.vue";
import ContributionStatistics from "./components/ContributionStatistics.vue";
import TopContributions from "./components/TopContributions.vue";

export default {
  name: "Overview",
  components: {
    ContentContainer,
    ProceedingList,
    AppointmentList,
    ProceedingStatistics,
    Documentations,
    ProceedingMap,
    ContributionStatistics,
    TopContributions
  },
  data () {
    return {
      mounted: false
    };
  },
  mounted () {
    this.mounted = true;
  },
  methods: {
    translate (tid) {
      return this.$t(tid);
    },
    teleportTarget (target, breakpoint = false) {
      return (!breakpoint ? "#" : "") + "breakpoint-" + (!breakpoint ? this.activeMediaBreakpoint : breakpoint) + "-" + target;
    }
  }
};
</script>

<template>
  <section
    class="Overview"
    :class="'Overview-' + activeMediaBreakpoint"
  >
    <template v-if="mounted">
      <Teleport :to="teleportTarget('map')">
        <ContentContainer
          :title="translate('components.ProceedingMap.title')"
          :icons="[
            {
              type: 'callback',
              ref: 'proceedingMap',
              title: translate('components.ProceedingMap.zoomIn.title'),
              method: 'zoomIn',
              icon: 'zoom_in'
            },
            {
              type: 'callback',
              ref: 'proceedingMap',
              title: translate('components.ProceedingMap.zoomOut.title'),
              method: 'zoomOut',
              icon: 'zoom_out'
            }
          ]"
        >
          <ProceedingMap ref="proceedingMap" />
        </ContentContainer>
      </Teleport>

      <Teleport :to="teleportTarget('proceedinglist')">
        <ContentContainer
          :title="translate('components.ProceedingList.title')"
          :icons="[
            {
              type: 'select',
              stateid: 'order',
              label: translate('components.ProceedingList.sort.title'),
              ref: 'proceedinglist',
              method: 'setSorting',
              options: [
                {
                  label: translate('components.ProceedingList.sort.alphabetical'),
                  arguments: ['name']
                },
                {
                  label: translate('components.ProceedingList.sort.recentFirst'),
                  arguments: ['startdate']
                }
              ]
            }
          ]"
        >
          <ProceedingList ref="proceedinglist" />
        </ContentContainer>
      </Teleport>

      <Teleport :to="teleportTarget('documents')">
        <ContentContainer
          :title="translate('components.Documents.title')"
          :icons="[
            {
              type: 'info',
              text: translate('components.Documents.infoText')
            }
          ]"
        >
          <Documentations ref="documentations" />
        </ContentContainer>
      </Teleport>

      <Teleport :to="teleportTarget('appointments')">
        <ContentContainer
          :title="translate('components.AppointmentList.title')"
          :icons="[
            {
              type: 'info',
              text: translate('components.AppointmentList.infoText')
            }
          ]"
        >
          <AppointmentList />
        </ContentContainer>
      </Teleport>

      <Teleport :to="teleportTarget('contributions')">
        <ContentContainer
          :title="translate('components.TopContributions.title')"
          :icons="[
            {
              type: 'info',
              text: translate('components.TopContributions.infoText')
            }
          ]"
        >
          <TopContributions />
        </ContentContainer>
      </Teleport>

      <Teleport :to="teleportTarget('contributionstatistics')">
        <ContentContainer
          :title="translate('components.ContributionStatistics.title')"
          :icons="[
            {
              type: 'toggle',
              ref: 'ContributionStatistics',
              method: 'setDisplayType',
              default: 'charts',
              options: {
                charts: {
                  icon: 'piechart',
                  title: translate('components.Overview.displayToggles.charts'),
                  arguments: ['charts']
                },
                table: {
                  icon: 'table',
                  title: translate('components.Overview.displayToggles.tables'),
                  arguments: ['tables']
                }
              }
            }
          ]"
        >
          <ContributionStatistics ref="ContributionStatistics" />
        </ContentContainer>
      </Teleport>

      <Teleport :to="teleportTarget('proceedingstatistics')">
        <ContentContainer
          :title="translate('components.ProceedingStatistics.title')"
          :icons="[
            {
              type: 'toggle',
              ref: 'ProceedingStatistics',
              method: 'setDisplayType',
              default: 'charts',
              options: {
                charts: {
                  icon: 'piechart',
                  title: translate('components.Overview.displayToggles.charts'),
                  arguments: ['charts']
                },
                table: {
                  icon: 'table',
                  title: translate('components.Overview.displayToggles.tables'),
                  arguments: ['tables']
                },
              }
            },
            {
              type: 'info',
              text: 'Ein Beteiligungsverfahren kann über mehrere Jahre laufen, \
              sich auf mehrere Themen beziehen und mehrere Gebiete umfassen. \
              Die Summe der Verfahren nach Jahren, Themen und Gebieten kann also die Zahl „Verfahren Gesamt“ übersteigen.'
            }
          ]"
        >
          <ProceedingStatistics ref="ProceedingStatistics" />
        </ContentContainer>
      </Teleport>
    </template>

    <div v-show="activeMediaBreakpoint === 'xs'">
      <div class="row">
        <div class="column col-12">
          <div
            :id="teleportTarget('map', 'xs')"
            class="minHeight"
          />

          <div :id="teleportTarget('proceedinglist', 'xs')" />

          <div
            :id="teleportTarget('documents', 'xs')"
            class="noFlexGrow"
          />

          <div :id="teleportTarget('appointments', 'xs')" />

          <div :id="teleportTarget('contributions', 'xs')" />

          <div :id="teleportTarget('contributionstatistics', 'xs')" />

          <div :id="teleportTarget('proceedingstatistics', 'xs')" />
        </div>
      </div>
    </div>

    <div v-show="activeMediaBreakpoint === 'sm'">
      <div class="row minHeight">
        <div class="column col-12">
          <div :id="teleportTarget('map', 'sm')" />
        </div>
      </div>

      <div class="row">
        <div class="column col-6">
          <div :id="teleportTarget('proceedinglist', 'sm')" />

          <div
            :id="teleportTarget('documents', 'sm')"
            class="noFlexGrow"
          />

          <div :id="teleportTarget('appointments', 'sm')" />

          <div :id="teleportTarget('contributions', 'sm')" />
        </div>

        <div class="column col-6">
          <div :id="teleportTarget('contributionstatistics', 'sm')" />

          <div :id="teleportTarget('proceedingstatistics', 'sm')" />
        </div>
      </div>
    </div>

    <div v-show="activeMediaBreakpoint === 'md'">
      <div class="row minHeight">
        <div class="column col-12">
          <div :id="teleportTarget('map', 'md')" />
        </div>
      </div>

      <div class="row">
        <div class="column col-4">
          <div :id="teleportTarget('proceedinglist', 'md')" />

          <div
            :id="teleportTarget('documents', 'md')"
            class="noFlexGrow"
          />

          <div :id="teleportTarget('appointments', 'md')" />
        </div>

        <div class="column col-4">
          <div :id="teleportTarget('contributions', 'md')" />

          <div :id="teleportTarget('contributionstatistics', 'md')" />
        </div>

        <div class="column col-4">
          <div :id="teleportTarget('proceedingstatistics', 'md')" />
        </div>
      </div>
    </div>

    <div v-show="activeMediaBreakpoint === 'lg'">
      <div class="row">
        <div class="column col-9">
          <div :id="teleportTarget('map', 'lg')" />
        </div>

        <div class="column col-3">
          <div :id="teleportTarget('proceedingstatistics', 'lg')" />
        </div>
      </div>

      <div class="row">
        <div class="column col-3">
          <div :id="teleportTarget('proceedinglist', 'lg')" />
        </div>

        <div class="column col-3">
          <div :id="teleportTarget('contributions', 'lg')" />
        </div>

        <div class="column col-3">
          <div :id="teleportTarget('contributionstatistics', 'lg')" />
        </div>

        <div class="column col-3">
          <div
            :id="teleportTarget('documents', 'lg')"
            class="noFlexGrow"
          />

          <div :id="teleportTarget('appointments', 'lg')" />
        </div>
      </div>
    </div>

    <div v-show="activeMediaBreakpoint === 'xl'">
      <div class="row">
        <div class="column col-6">
          <div :id="teleportTarget('map', 'xl')" />
        </div>

        <div class="column col-2">
          <div :id="teleportTarget('proceedinglist', 'xl')" />

          <div
            :id="teleportTarget('documents', 'xl')"
            class="noFlexGrow"
          />

          <div :id="teleportTarget('appointments', 'xl')" />
        </div>

        <div class="column col-2">
          <div :id="teleportTarget('contributions', 'xl')" />

          <div :id="teleportTarget('contributionstatistics', 'xl')" />
        </div>

        <div class="column col-2">
          <div :id="teleportTarget('proceedingstatistics', 'xl')" />
        </div>
      </div>
    </div>
  </section>
</template>

<style lang="scss">
@import "../../scss/_global.scss";

section.Overview {
  display: flex;
  flex: 1;
  flex-direction: column;

  & > div {
    display: flex;
    flex: 1;
    flex-direction: column;

    & > div.row {
      flex: 1;
      display: flex;

      & > div.column {
        float: left;
        flex: 1;
        display: flex;
        flex-direction: column;

        & > div {
          display: flex;
          flex-direction: column;
          flex: 1;

          &.noFlexGrow {
            flex: 0;
          }
        }
      }
    }
  }

  div.minHeight {
    min-height: 75vh;
  }
}
</style>
